<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Inequality Math</TITLE>
<link href="suifmath_12.html" rel=Next>
<link href="suifmath_10.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_10.html">previous</A>, <A HREF="suifmath_12.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC11" HREF="suifmath_toc.html#TOC11">Linear Inequality Math</A></H2>
<P>
<A NAME="IDX229"></A>
<A NAME="IDX230"></A>
<A NAME="IDX231"></A>

</P>
<DL COMPACT>

<DT><CODE>i = ~A</CODE>
<DD>
<A NAME="IDX232"></A>
<A NAME="IDX233"></A>
<A NAME="IDX234"></A>
Check if there does not exist an integer solution to the given system of
inequalities. <VAR>i</VAR> is set to TRUE if NO SOLUTION and returns FALSE if a
solution exists to the system of inequalities.

<DT><CODE>i = (A == B)</CODE>
<DD>
<A NAME="IDX235"></A>
<A NAME="IDX236"></A>
<A NAME="IDX237"></A>
<VAR>i</VAR> is set to TRUE if both systems of inequalities represent the same
set of integer points.

<DT><CODE>i = (A &#62;&#62; B)</CODE>
<DD>
<A NAME="IDX238"></A>
<A NAME="IDX239"></A>
<A NAME="IDX240"></A>
This is the subset or <EM>"is contained?"</EM> operator.
It checks if all the integer points given by the set of inequalities of 
<VAR>B</VAR> are also included in the polyhedron defined by the system of
inequalities <VAR>A</VAR>.  

<DT><CODE>i = col_lcm(j);</CODE>
<DD>
<A NAME="IDX241"></A>
<A NAME="IDX242"></A>
Find the least common multiplier of all the numbers in the <VAR>j</VAR>-th
column. 

<DT><CODE>i = col_gcd(j);</CODE>
<DD>
<A NAME="IDX243"></A>
<A NAME="IDX244"></A>
Find the greatest common divider of all the numbers in the <VAR>j</VAR>-th
column. 

<DT><CODE>normalize();</CODE>
<DD>
<A NAME="IDX245"></A>
<A NAME="IDX246"></A>
<A NAME="IDX247"></A>
Normalize the inequalities by dividing each inequality by the gcd.  In
<CODE>normalize(TRUE)</CODE> the constant term of each inequality is adjusted
to make the bounds tight without changing the integer solution. 

<DT><CODE>del_zeros();</CODE>
<DD>
<A NAME="IDX248"></A>
<A NAME="IDX249"></A>
Remove the rows that have all zero values.  If the coefficient values and the
constant of a constraint are all zeros, it represents <VAR>0 &#62;= 0</VAR>, thus
void of any information. 

<DT><CODE>del_unused_var();</CODE>
<DD>
<A NAME="IDX250"></A>
<A NAME="IDX251"></A>
Each column (other than the first) represents coefficients of a variable.
If no non-zero coefficient exists for  a variable (the column is all
zeros) remove that variable from the system.
Since no inequality uses this variable, getting rid of that variable
does not change the problem. 

<DT><CODE>del_repetition();</CODE>
<DD>
<A NAME="IDX252"></A>
<A NAME="IDX253"></A>
If the same inequality is repeated multiple times, get rid of all the
copies but one.

<DT><CODE>del_loose();</CODE>
<DD>
<A NAME="IDX254"></A>
<A NAME="IDX255"></A>
If two inequalities have similar coefficients but have different
constant terms, eliminate the slacker inequality.

<DT><CODE>min_constant();</CODE>
<DD>
<A NAME="IDX256"></A>
...

<DT><CODE>max_rank();</CODE>
<DD>
<A NAME="IDX257"></A>
<A NAME="IDX258"></A>
Position of the rightmost column that has a non-zero element.

<DT><CODE>A = B.filter(a, i, j);</CODE>
<DD>
<A NAME="IDX259"></A>
<DT><CODE>A = B.filter_thru(a, i);</CODE>
<DD>
<A NAME="IDX260"></A>
<DT><CODE>A = B.filter_away(a, i);</CODE>
<DD>
<A NAME="IDX261"></A>
<SAMP>`Filter'</SAMP> functions are used to filter a subset of inequalities from a
given set of inequalities.  The filter kernel <VAR>a</VAR> has an entry for
each column of <VAR>B</VAR>.  If <VAR>a[x]</VAR> is 0 the column <VAR>x</VAR> does not
affect the results while a 1 makes that column active.  The variable
<VAR>i</VAR> is the sign of the participating coefficients. If <VAR>i</VAR> is 0,
all active columns with non-zero coefficients participate; if <VAR>i</VAR> is 1,
only the active columns with positive coefficients participate; <VAR>i</VAR>
is -1, only the active columns with negative coefficient participate.
Finally the variable <VAR>j</VAR> in the function <CODE>filter</CODE> determines
the filter operation. If <VAR>j</VAR> is 1 the operation is
<CODE>filter_thru</CODE> and when <VAR>j</VAR> is -1 the operation is
<CODE>filter_away</CODE>.

<BLOCKQUOTE>
<P>
Let's look at an example loop nest. 

<PRE>
for i1 = 0 to N do       
    for i2 = 0 to MIN(i1, N) do       
        for i3 = 1 to MIN(i2, N-1) do       
            for i4 = 0 to 100 do       
                ...
</PRE>

<P>
The set of inequalities representing this loop nest is:

<PRE>
//              N  i1  i2  i3  i4
        [   0   0   1   0   0   0 ]
        [   0   1  -1   0   0   0 ]
        [   0   0   0   1   0   0 ]
    A = [   0   0   1  -1   0   0 ]
        [   0   1   0  -1   0   0 ]
        [  -1   0   0   0   1   0 ]
        [   0   0   0   1  -1   0 ]
        [   1   1   0   0  -1   0 ]
        [   0   0   0   0   0   1 ]
        [ 100   0   0   0   0  -1 ]
</PRE>

<P>
Let's see how to extract the lower and upper bounds of the loop <VAR>i2</VAR>
from the system of inequalities <VAR>A</VAR>. 

<PRE>
constraint c(6);

// First remove all the inequalities representing 
// the bounds of inner loops (<VAR>i3</VAR> and <VAR>i4</VAR>). This step
// will remove the 7th inequality where <VAR>i2</VAR> is in
// the bounds of <VAR>i3</VAR>.
c = 0;
c[4] = 1
c[5] = 1
//   c =[   0   0   0   0   1   1 ]

B = A.filter_away(c, 0);
//      [   0   0   1   0   0   0 ]
//      [   0   1  -1   0   0   0 ]
//  B = [   0   0   0   1   0   0 ]
//      [   0   0   1  -1   0   0 ]
//      [   0   1   0  -1   0   0 ]

// Now get the inequalities that represent the bounds 
// of <VAR>i2</VAR>. After the previous step, all the inequalities 
// with a non-zero coefficient for <VAR>i2</VAR> represents a 
// bound for the <VAR>i2</VAR> loop.
c = 0;
c[3] = 1
//  c = [   0   0   0   1   0   0 ]

LB = B.filter_thru(c,  1);
// The lower bound of the loop i2 is:
// LB = [   0   0   0   1   0   0 ]

UB = B.filter_thru(c, -1);
// The upper bound of the loop i2 is:
// UB = [   0   0   1  -1   0   0 ]
//      [   0   1   0  -1   0   0 ]
</PRE>

</BLOCKQUOTE>

</DL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_10.html">previous</A>, <A HREF="suifmath_12.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
